; burneye cryptographic layer 1 & 2 cracker
; by [ByteRage] / UNF
;
; (C) Copyright UNF security, 2002
; All Rights Reserved

section .data

initstate	db   0h,   1h,   2h,   3h,   4h,   5h,   6h,   7h,
		db   8h,   9h,  0ah,  0bh,  0ch,  0dh,  0eh,  0fh,
		db  10h,  11h,  12h,  13h,  14h,  15h,  16h,  17h,
		db  18h,  19h,  1ah,  1bh,  1ch,  1dh,  1eh,  1fh,
		db  20h,  21h,  22h,  23h,  24h,  25h,  26h,  27h,
		db  28h,  29h,  2ah,  2bh,  2ch,  2dh,  2eh,  2fh,
		db  30h,  31h,  32h,  33h,  34h,  35h,  36h,  37h,
		db  38h,  39h,  3ah,  3bh,  3ch,  3dh,  3eh,  3fh,
		db  40h,  41h,  42h,  43h,  44h,  45h,  46h,  47h,
		db  48h,  49h,  4ah,  4bh,  4ch,  4dh,  4eh,  4fh,
		db  50h,  51h,  52h,  53h,  54h,  55h,  56h,  57h,
		db  58h,  59h,  5ah,  5bh,  5ch,  5dh,  5eh,  5fh,
		db  60h,  61h,  62h,  63h,  64h,  65h,  66h,  67h,
		db  68h,  69h,  6ah,  6bh,  6ch,  6dh,  6eh,  6fh,
		db  70h,  71h,  72h,  73h,  74h,  75h,  76h,  77h,
		db  78h,  79h,  7ah,  7bh,  7ch,  7dh,  7eh,  7fh,
		db  80h,  81h,  82h,  83h,  84h,  85h,  86h,  87h,
		db  88h,  89h,  8ah,  8bh,  8ch,  8dh,  8eh,  8fh,
		db  90h,  91h,  92h,  93h,  94h,  95h,  96h,  97h,
		db  98h,  99h,  9ah,  9bh,  9ch,  9dh,  9eh,  9fh,
		db 0a0h, 0a1h, 0a2h, 0a3h, 0a4h, 0a5h, 0a6h, 0a7h,
		db 0a8h, 0a9h, 0aah, 0abh, 0ach, 0adh, 0aeh, 0afh,
		db 0b0h, 0b1h, 0b2h, 0b3h, 0b4h, 0b5h, 0b6h, 0b7h,
		db 0b8h, 0b9h, 0bah, 0bbh, 0bch, 0bdh, 0beh, 0bfh,
		db 0c0h, 0c1h, 0c2h, 0c3h, 0c4h, 0c5h, 0c6h, 0c7h,
		db 0c8h, 0c9h, 0cah, 0cbh, 0cch, 0cdh, 0ceh, 0cfh,
		db 0d0h, 0d1h, 0d2h, 0d3h, 0d4h, 0d5h, 0d6h, 0d7h,
		db 0d8h, 0d9h, 0dah, 0dbh, 0dch, 0ddh, 0deh, 0dfh,
		db 0e0h, 0e1h, 0e2h, 0e3h, 0e4h, 0e5h, 0e6h, 0e7h,
		db 0e8h, 0e9h, 0eah, 0ebh, 0ech, 0edh, 0eeh, 0efh,
		db 0f0h, 0f1h, 0f2h, 0f3h, 0f4h, 0f5h, 0f6h, 0f7h,
		db 0f8h, 0f9h, 0fah, 0fbh, 0fch, 0fdh, 0feh, 0ffh

section .text

; this is the most important code of all in terms of optimization,
; since it will be 'unrolled' 256 times
%macro		corecode 0
		mov	bl, [edi]
		add	ecx, eax		; cl += key[0..19]
		add	ecx, ebx		; cl += state[0..255]
		and	ecx, 0ffh
		mov	al, [ebp+ecx]
		mov	[ebp+ecx], bl
		stosb

%endmacro

%macro		iterate4 0
		lodsd
		corecode
		ror	eax, 8
		corecode
		ror	eax, 8
		corecode
		ror	eax, 8
		corecode
%endmacro

%macro		iterate20 0
		mov	esi, edx
		iterate4
		iterate4
		iterate4
		iterate4
		iterate4		
%endmacro

global rc4check

rc4check:
		push	ebp
		mov	ebp, esp
                sub     esp, 100h
                push    edi
                push    esi
                push    ebx

		; initialize state[0] .. state[255]

		mov	esi, dword initstate
		lea	edi, [ebp-100h]
		mov	ecx, 040h
		rep	movsd
		
		xor	ebx, ebx
		xor	ecx, ecx		; index2
		mov	edx, dword [ebp+8]      ; ptr to key[0] (20 byte key)
		lea	edi, [ebp-100h]   	; ptr to state[0]
		sub	ebp, 100h
		iterate20
		iterate20
		iterate20
		iterate20
		iterate20
		iterate20
		iterate20
		iterate20
		iterate20
		iterate20
		iterate20
		iterate20
		mov	esi, edx
		iterate4
		iterate4
		iterate4
		iterate4		
		add	ebp, 100h

		; initialization done... decrypt!
		
		mov	eax, dword [ebp+0Ch]	; dword to decrypt

		xor	edx, edx
		mov	dl, [ebp-0ffh]		; bl = state[1] (=state[x])
		mov	bl, [ebp+edx-100h]	; cl = state[state[x]]
						; (=state[x]+y=y

		mov	[ebp+edx-100h], dl	; swap
		mov	[ebp-0ffh], bl

		mov	ecx, ebx
		add	ecx, edx
		and	ecx, 0ffh
		
		mov	cl, [ebp+ecx-100h]

		cmp	al, cl			; state[xorindex]
		jz	okaykey

		xor	eax, eax
                lea     esp, [ebp-10Ch]
		
		pop	ebx
		pop	esi
		pop	edi
		leave
		retn
		
okaykey:
		ror	eax, 8
		
		xor	ebx, ebx
		mov	bl, [ebp-0feh]		; bl = state[2] (=state[x])
		add	edx, ebx		; dl = state[2]+y
		and	edx, 0ffh
		mov	cl, [ebp+edx-100h]	; dl = state[state[2]+y] (=state[y])

		mov	[ebp+edx-100h], bl	; swap
		mov	[ebp-0feh], cl

		add	ecx, ebx
		and	ecx, 0ffh
		
		mov	cl, [ebp+ecx-100h]
		
		cmp	al, cl			; state[xorindex] 
		jz	okaykey2

		xor	eax, eax
                lea     esp, [ebp-10Ch]
		
		pop	ebx
		pop	esi
		pop	edi
		leave
		retn

okaykey2:
		ror	eax, 8

		xor	ebx, ebx
		mov	bl, [ebp-0fdh]		; bl = state[3] (=state[x])
		add	edx, ebx		; dl = state[3]+y
		and	edx, 0ffh
		mov	cl, [ebp+edx-100h]	; dl = state[state[3]+y] (=state[y])

		mov	[ebp+edx-100h], bl	; swap
		mov	[ebp-0fdh], cl

		add	ecx, ebx
		and	ecx, 0ffh
		
		mov	cl, [ebp+ecx-100h]
		cmp	al, cl			; state[xorindex]
		jnz	wrongkey		
		ror	eax, 8

		xor	ebx, ebx
		mov	bl, [ebp-0fch]		; bl = state[4] (=state[x])
		add	edx, ebx		; dl = state[4]+y
		and	edx, 0ffh
		mov	cl, [ebp+edx-100h]	; dl = state[state[4]+y] (=state[y])

		mov	[ebp+edx-100h], bl	; swap
		mov	[ebp-0fch], cl

		add	ecx, ebx
		and	ecx, 0ffh
		
		mov	cl, [ebp+ecx-100h]
		cmp	al, cl			; state[xorindex]
		jnz	wrongkey		
		mov	eax, 1
		jmp	endfunc
wrongkey:		
		xor	eax, eax
endfunc:
                lea     esp, [ebp-10Ch]
		
		pop	ebx
		pop	esi
		pop	edi
		leave
		retn
